/*---------------------------------
Fred Paulino Ferreira - 47662
Exercicio de INF251
Multiplicador de n bits (n fornecido pelo usurio)
Funcoes auxiliares
12/10/2004
---------------------------------*/

#include <iostream.h>
#include <fstream.h>


//Armazena no arquivo origem.txt o origem do fio a ligar
void carregaArqOrigem(int n, int *bits)
{
	//O arquivo abaixo armazena todas as entradas dos somadores
	fstream origem("origem.txt", ios::out); //Cria o arquivo para escrita
	if(!origem){
		cout << "Erro ao abrir o arquivo \"origem.txt\"" << endl;
		exit(-1);
	}

	int k,x=n;
	for(int i = 0 ; i < 2*n - 1 ; i++){
		if(i>=n){
			x--;
			k = n-1;
		}
		else
			k = i;

		for(int j = n - x ; j <= (i>=n ? n-1 : i) ; j++){
			if( k + j == i)
				origem << "A" << k << "B" << j << " Y" << endl;
			k--;
		}
		for(int j = 0 ; i > 0 && j < bits[i]/2; j++)
			origem << "somador_" << j << "_coluna_" << i << " soma" << endl;
		for(int j = 0 ; i > 0 && j < bits[i]/2; j++)
			origem << "somador_" << j << "_coluna_" << i << " vai_um" << endl;

	}
	origem << "END";
	origem.close();

} //Fim da funcao carregaArqOrigem


//Armazena no arquivo destino.txt a destino do fio a ligar
void carregaArqDestino(int n, int *bits)
{
	//O arquivo abaixo armazena todas as entradas dos somadores
	fstream destino("destino.txt", ios::out); //Cria o arquivo para escrita
	if(!destino){
		cout << "Erro ao abrir o arquivo \"destino.txt\"" << endl;
		exit(-1);
	}

	destino << "MERGE A0" << endl;
	for(int i = 1 ; i < 2*n - 1 ; i++){
		for(int j = 0 ; j <= bits[i]/2 - 1 ; j++){
			destino << "somador_" << j << "_coluna_" << i << " Ai" << endl;
			destino << "somador_" << j << "_coluna_" << i << " Bi" << endl;
			if(bits[i]%2 != 0 || j != bits[i]/2 - 1)	
				destino << "somador_" << j << "_coluna_" << i << " vem_um" << endl;			
		}
		destino << "MERGE A" << i << endl;
	}
		
	if(n>1)
		destino << "MERGE A" << 2*n - 1 << endl;

	destino << "END";
	destino.close();

} //Fim da funcao carregaArqDestino


void LigaFios(int &NumFio, fstream &arq){
	fstream origem("origem.txt", ios::in); //Cria o arquivo para escrita
	if(!origem){
		cout << "Erro ao abrir o arquivo \"origem.txt\"" << endl;
		exit(-1);
	}

	fstream destino("destino.txt", ios::in); //Cria o arquivo para escrita
	if(!destino){
		cout << "Erro ao abrir o arquivo \"destino.txt\"" << endl;
		exit(-1);
	}

	origem.seekg(0,ios::beg);
	destino.seekg(0,ios::beg);

	char str1[51],str2[51];
//	str1[0]='-';str1[1]='\0';
	origem.getline(str1,50);
	destino.getline(str2,50);
	while(strcmp(str1,"END")){
		arq << "\nhades.signals.SignalStdLogic1164 FIO_" << NumFio++ << " 2 " 
			<< str1 << " " << str2 << " 0 0";
		origem.getline(str1,50);
		destino.getline(str2,50);
	}

} //Fim da funcao LigaFios
